/* values possibly found in EGerrno following EGlib calls */
/* DB, September 1991 */

#ifndef INCeglibh
#define INCeglibh

#define EG_PING_TIMEOUT 2

#ifdef WIN32
#define DllImport	__declspec( dllimport )
#define DllExport	__declspec( dllexport )
#else
#define DllImport extern
#define DllExport 
#endif

#if defined (__cplusplus) || defined (c_plusplus)
extern "C" {
#endif

#ifdef LIBEG_ITSELF
#define DllXXport DllExport
#else
#define DllXXport DllImport
#endif
	
DllImport int sasLogging;
DllImport int sasDebug;
DllImport int SASerrno;

#if defined (__cplusplus) || defined (c_plusplus)
}
#endif

#define EGERR 1
#define EG_not_yet_implemented				((EGERR<<16)+1)
#define EG_no_suitable_resource_claimed 		((EGERR<<16)+2)
#define EG_name_or_pattern_too_long 			((EGERR<<16)+3)
#define EG_register_not_known 				((EGERR<<16)+4)
#define EG_experiment_already_connected 		((EGERR<<16)+5)
#define EG_cant_open_experiment_file 			((EGERR<<16)+6)
#define EG_cant_memorymap_experiment_file 		((EGERR<<16)+7)
#define EG_no_experiment_connected 			((EGERR<<16)+8)
#define EG_apparatus_already_attached 			((EGERR<<16)+9)
#define EG_cant_open_apparatus_file 			((EGERR<<16)+10)
#define EG_error_parsing_apparatus_file 		((EGERR<<16)+11)
#define EG_some_resources_still_claimed 		((EGERR<<16)+12)
#define EG_cant_claim_all_resources 			((EGERR<<16)+13)
#define EG_cant_free_all_resources 			((EGERR<<16)+14)
#define EG_apparatus_file_punctuation_expected 		((EGERR<<16)+15)
#define EG_apparatus_file_number_expected 		((EGERR<<16)+16)
#define EG_apparatus_file_string_expected 		((EGERR<<16)+17)
#define EG_apparatus_file_keyword_expected 		((EGERR<<16)+18)
#define EG_apparatus_file_invalid_character 		((EGERR<<16)+19)
#define EG_apparatus_file_premature_EOF 		((EGERR<<16)+20)
#define EG_cant_create_RPC_client 			((EGERR<<16)+21)
#define EG_too_many_resources 				((EGERR<<16)+22)
#define EG_capability_file_already_exists               ((EGERR<<16)+23)
#define EG_cant_open_capability_file                    ((EGERR<<16)+24)
#define EG_cant_initialise_capability_file              ((EGERR<<16)+25)
#define EG_cant_access_experiment_directory             ((EGERR<<16)+26)
#define EG_cant_delete_capability_file                  ((EGERR<<16)+27)
#define EG_no_reply_from_ping_attempt 			((EGERR<<16)+28)
#define EG_max_errno 28

#define ERSERR 2
#define ERS_resource_not_known                          ((ERSERR<<16)+1)
#define ERS_resource_already_in_use                     ((ERSERR<<16)+2)
#define ERS_capability_invalid                          ((ERSERR<<16)+3)
#define ERS_register_not_known                          ((ERSERR<<16)+4)
#define ERS_types_incompatible                          ((ERSERR<<16)+5)
#define ERS_register_already_defined                    ((ERSERR<<16)+6)
#define ERS_class_not_known                             ((ERSERR<<16)+7)
#define ERS_application_not_responding                  ((ERSERR<<16)+8)
#define ERS_invalid_cookie                              ((ERSERR<<16)+9)
#define ERS_application_detected_failure                ((ERSERR<<16)+10)
#define ERS_illegal_register_name                       ((ERSERR<<16)+11)
#define ERS_out_of_memory                               ((ERSERR<<16)+12)
#define ERS_count_too_small                             ((ERSERR<<16)+13)
#define ERS_bad_request                                 ((ERSERR<<16)+14)
#define ERS_invalid_file_name                           ((ERSERR<<16)+15)

#define ESSERR 3
#define ESSERRNO    	        	                ((ESSERR<<16)+(unsigned short)(errno))
#define ESS_cannot_locate_spectrum                      ((ESSERR<<16)+1)

#define ETSERR 4
#define ETSERRNO    	        	                ((ETSERR<<16)+(unsigned short)(errno))

#if defined (__cplusplus) || defined (c_plusplus)
extern "C" {
#endif
DllXXport int EGerrno;
DllXXport int EGsetRegisterPath (char *name);
DllXXport int EGpingRegisterResource (char *name, int timeout);
DllXXport int EGinquireRegisters (char* pattern, char *buf);
DllXXport int EGinquireRegistersMore (char *buf);
DllXXport int EGreadRegister (char *name, char *value);
DllXXport int EGwriteRegister (char *name, char *value);
DllXXport int EGinitialiseRegister (char *name);
DllXXport int EGreadRegisters (char* pattern, char *namebuf, char *valuebuf);
DllXXport int EGreadRegistersMore (char *namebuf, char *valuebuf);
DllXXport int EGwriteRegisters (char *pattern, char *value);
DllXXport int EGinitialiseRegisters (char *pattern);
DllXXport int EGcreateRegister (char *name, char *rclass);
DllXXport int EGdestroyRegister (char *name);
DllXXport int EGdestroyRegisters (char *pattern);
DllXXport int EGgetObject (char *name, char *attributes);
DllXXport int EGsetObject (char *name, char *attributes);
DllXXport int EGgetObjects (char* pattern, char *namebuf, char *attributesbuf);
DllXXport int EGgetObjectsMore (char *namebuf, char *attributesbuf);
DllXXport int EGsetObjects (char *pattern, char *attributes);
DllXXport int EGgetClass (char *name, char *classbuf);
DllXXport int EGgetClasses (char* pattern, char *namebuf, char *classesbuf);
DllXXport int EGgetClassesMore (char *namebuf, char *classesbuf);
DllXXport int EGsetExperimentPath (char *name);
DllXXport int EGcreateExperiment (char *name);
DllXXport int EGdeleteExperiment (char *name);
DllXXport int EGconnectExperiment (char *name);
DllXXport int EGdisconnectExperiment ();
DllXXport int EGsetApparatusPath (char *name);
DllXXport int EGattachApparatus (char *name);
DllXXport int EGdetachApparatus (char *name);
DllXXport int EGclaimApparatus (char *name);
DllXXport int EGfreeApparatus (char *name);
DllXXport int EGdisplayResources (FILE *fp);
DllXXport int EGreturnResources (char *buffer, int len);
DllXXport char *EGerrorMessage (int num);
DllXXport int EGauthorise (char *user, char *password);
DllXXport int EGsetSpectrumDebug (int level);
DllXXport int EGsetSpectrumPath (char *name);
DllXXport int EGsetDefaultArray (int number);
DllXXport int EGpingSpectrumResource (char *name, int timeout);
DllXXport int EGcreate1dSpectrum (char *name, int base, int range, int layout, int type);
DllXXport int EGcreate2dSpectrum (char *name, int base1, int range1, 
                                           int base2, int range2, int layout, int type);
DllXXport int EGcreateSpectrum (char *name, int dimension, 
                                           int *base, int *range, int layout, int type);
DllXXport int EGdeleteSpectrum (char *name);
DllXXport int EGzeroSpectrum (char *name);
DllXXport int EGreadInformation (char *name, int number, char *buf);
DllXXport int EGwriteInformation (char *name, int number, char *buf);
DllXXport int EGreadAnnotation (char *name, int number, char *buf);
DllXXport int EGwriteAnnotation (char *name, int number, char *buf);
DllXXport int EGreadCalibration (char *name, int number, char *buf);
DllXXport int EGwriteCalibration (char *name, int number, char *buf);
DllXXport int EGreadEfficiency (char *name, int number, char *buf);
DllXXport int EGwriteEfficiency (char *name, int number, char *buf);
DllXXport int EGinquireSpectrum (char *name, int *dim, 
                              int *bases, int *ranges, int *layouts, int *types);
DllXXport int EGsetSpectrumArray (char *name, int number, int layout, int type);
DllXXport int EGinquireAddress (char *name, int *address);
DllXXport int EGsetDefaultCompression (int *ranges);
DllXXport int EGinquireDirectory (char* name, char *buf);
DllXXport int EGinquireDirectoryMore (char *buf);
DllXXport int EGread1dSpectrum (char *name, int base, int range, int *array, int type);
DllXXport int EGwrite1dSpectrum (char *name, int base, int range, int *array, int type);
DllXXport int EGread2dSpectrum (char *name, int base1, int range1, 
                             int base2, int range2, int *array, int type);
DllXXport int EGwrite2dSpectrum (char *name, int base1, int range1, int base2, 
                              int range2, int *array, int type);
DllXXport int EGreadSpectrum (char *name, int dimension, 
                             int *base, int *range, int *array, int type);
DllXXport int EGwriteSpectrum (char *name, int dimension,
                             int *base, int *range, int *array, int type);
DllXXport int EGspectrumErrorReport (char *name, char *report);
DllXXport int EGTSsetPath (char *name);
DllXXport int EGTSpingResource (char *name, int timeout);
DllXXport int EGTSclaimDrive (char *name, char *requested, char *allocated);
DllXXport int EGTSfreeDrive (char *name);
DllXXport int EGTSmountVolume (char *name, char *volume);
DllXXport int EGTSdismountVolume (char *name);
DllXXport int EGTSinquireFileStatus (char *name, int *lstatus, int *sstate,
				  char *info, char *device, char *rdevice,
				  char *vname, char *fname, int *mode,
				  int *ltype, int *rlen, int *blen, int *dlen,
				  int *magic, int *magicwr, int *magicrd,
				  int *blkCnt, int *bytCnt, int *rate);
DllXXport int EGTSopenFile (char *name, int mode, int ltype, int rlen, int blen,
			 char *fname);
DllXXport int EGTScloseFile (char *name);
DllXXport int EGTSsetState (char *name, long state);
DllXXport int EGTSgetState (char *name, long *state);
DllXXport int EGTSsetStream (char *name, int stream, int mode, int len,
			  char **ids);
DllXXport int EGTSgetStream (char *name, int stream, int *mode, int *len,
			  char **ids);
DllXXport int EGTSinquireStreamState (char *name, int stream,  int *state,
				   int *blkCnt, int *bytCnt, int *rate);
DllXXport int EGTSinquireDriveStatus(char *name, char *type, int *length,
				  int *written, int *remain, int *errors,
				  int *infolen, char *info);
DllXXport int EGTSidentifyVolume(char *name);
DllXXport int EGTSresetDrive(char *name);
DllXXport int EGTSinitialiseVolume(char *name, char *volume, int labelling,
				int density, char *oldvolume);
DllXXport int EGTSinquireDrives (char *name, int *len, int *statuses,
			      char **realnames, char **typenames);
DllXXport int EGTSmoveTape(char *name, int source, int dest);
DllXXport int EGTSpositionChanger(char *name, int dest);
DllXXport int EGTSinquireElementStatus(char *name, int location, int *state, int *full, int *source);

DllXXport int EGTSinquireGANILStatus (char *name, int *acq, int *store, int *replay, int *simul, int *run);
DllXXport int EGTSsetRun (char *name, long run);

#if defined (__cplusplus) || defined (c_plusplus)
   }
#endif

#endif
